﻿package com 
{
	import flash.display.Sprite;
	import flash.text.TextField;
	import flash.text.TextFieldAutoSize;
	import flash.text.TextFormat;
	import flash.text.TextFormatAlign;
	
	import caurina.transitions.Tweener;
	
	/**
	 * HUD - HUD display
	 * 
	 * @author Devin Reimer - blog.almostlogical.com
	 */ 
	public class HUD extends Sprite
	{
		private var hudWidth:int;
		private var hudHeight:int;
		
		private var currentStatusTF:TextField;
		private var instructionMessage:TextField;
		private var currentTimeTF:TextField;
		
		public function HUD(theHudWidth:int,theHudHeight:int) 
		{
			var instructionFormat:TextFormat;
			hudWidth = theHudWidth;
			hudHeight = theHudHeight;
			
			instructionMessage = new TextField();
			instructionFormat  = new TextFormat(null, 35, 0x000000);
			instructionMessage.defaultTextFormat = instructionFormat;
			instructionMessage.text = "Click to Start Game";
			instructionMessage.autoSize = TextFieldAutoSize.LEFT;
			instructionMessage.x= (hudWidth - instructionMessage.width) / 2;
			instructionMessage.y = (hudHeight / 2) - 80;
			addChild(instructionMessage);
		}
		
		public function createHUD():void
		{
			var backgroundSprite:Sprite = new Sprite();
			var blogNameTF:TextField;
			var instructionFormat:TextFormat;
			
			backgroundSprite.graphics.beginFill(0xFFFFFF);
			backgroundSprite.graphics.drawRect(0, 0, 200, 20);
			backgroundSprite.graphics.endFill();
			
			currentStatusTF = new TextField();
		
			currentStatusTF.text = "Loading...";
			currentStatusTF.textColor = 0xF70000;
			currentStatusTF.autoSize = TextFieldAutoSize.LEFT;
			currentStatusTF.x = 20;
			currentStatusTF.y = 2;
			currentStatusTF.width = 200;
			backgroundSprite.addChild(currentStatusTF);
			
			backgroundSprite.x = (hudWidth - backgroundSprite.width);
			addChild(backgroundSprite);
			
			removeChild(instructionMessage);
			instructionMessage = new TextField();
			instructionFormat  = new TextFormat(null, 35, 0xF70000);
			instructionFormat.align = TextFormatAlign.CENTER;
			instructionMessage.defaultTextFormat = instructionFormat;
			instructionMessage.text = "Knock off all red boxes to win!\nUse Arrow Keys to Play";
			instructionMessage.autoSize = TextFieldAutoSize.LEFT;
			instructionMessage.x= (hudWidth - instructionMessage.width) / 2;
			//instructionMessage.width = stage.stageWidth;
			instructionMessage.y = (hudHeight / 2) - 80;
			addChild(instructionMessage);
			
			blogNameTF = new TextField();
			blogNameTF.text = "http://blog.almostlogical.com - Devin Reimer";
			blogNameTF.textColor = 0xFFFFFF;
			blogNameTF.autoSize = TextFieldAutoSize.LEFT;
			blogNameTF.x = (hudWidth - blogNameTF.width);
			blogNameTF.y = (hudHeight - blogNameTF.height);
			addChild(blogNameTF);
			
			createTimer();
			
			Tweener.addTween(instructionMessage, { alpha:0, time:3, onComplete:removeMessage } ); //alpha won't work until font is embedded
		}
		
		private function createTimer():void
		{
			var backgroundSprite:Sprite = new Sprite();
			backgroundSprite.graphics.beginFill(0xFFFFFF);
			backgroundSprite.graphics.drawRect(0, 0, 170, 20);
			backgroundSprite.graphics.endFill();
			
			//new Date().
			
			currentTimeTF = new TextField();
		
			currentTimeTF.text = "";
			currentTimeTF.textColor = 0xF70000;
			currentTimeTF.autoSize = TextFieldAutoSize.LEFT;
			currentTimeTF.x = 10;
			currentTimeTF.y = 2;
			currentTimeTF.width = 170;
			backgroundSprite.addChild(currentTimeTF);
			
			//backgroundSprite.x = (hudWidth - backgroundSprite.width);
			addChild(backgroundSprite);
		}
		
		public function updateHUDText(markerRemaining:int,totalMarkers:int,timePassedMilliseconds:Number)
		{
			if (markerRemaining == 0)
			{
				currentStatusTF.text = "Winner!!!";
				instructionMessage.text = "Winner!!!";
				instructionMessage.autoSize = TextFieldAutoSize.LEFT;
				instructionMessage.x= (stage.stageWidth - instructionMessage.width) / 2;
				addChild(instructionMessage);
			}
			else
			{
				currentStatusTF.text = "Red Boxes Remaining: " + markerRemaining + " out of " + totalMarkers;
				currentTimeTF.text = "Time Passed: " + formatTime(timePassedMilliseconds) + " seconds";
			}
		}
		
		private function formatTime(timeMilliseconds:Number):String
		{
			var minutes:int;
			var seconds:int;
			var milliseconds:int;
			var minutesStr:String = "";
			var secondsStr:String = "";
			var millisecondStr:String = "";
			
			minutes = Math.floor(timeMilliseconds / (1000 * 60));
			timeMilliseconds -= minutes * (1000 * 60);
			
			seconds = Math.floor(timeMilliseconds / 1000);
			timeMilliseconds -= seconds * (1000);
			
			millisecondStr = String(timeMilliseconds);
			
			if (minutes < 10)
			{
				minutesStr += "0";
			}
			minutesStr += minutes;
			
			if (seconds < 10)
			{
				secondsStr += "0";
			}
			secondsStr += seconds;	
			
			millisecondStr = millisecondStr.substr(0, 2);
			
			return minutesStr + ":" + secondsStr;
			
		}
		
		private function removeMessage():void
		{
			removeChild(instructionMessage);
		}
	}
	
}