﻿package com.objects
{
	import jiglib.physics.RigidBody;
	import org.papervision3d.core.math.Number3D;
	
	/**
	 * AdvancedPhysicsObject - used to store information about the physics objects
	 * 
	 * @author Devin Reimer - blog.almostlogical.com
	 */ 
	public class AdvancedPhysicsObject 
	{		
		private var _physicsObj:RigidBody;
		private var _name:String;
		private var _orginPosition:Number3D;
		private var _isResettable:Boolean;
		private var _isMarker:Boolean;
		
		public function AdvancedPhysicsObject(physicsObj:RigidBody, name:String, orginPos:Number3D, isMarker:Boolean = false, isResettable:Boolean = false ) 
		{
			if (isMarker) //markers can not be reset
			{
				isResettable = false;
			}
			
			_physicsObj = physicsObj;
			_name = name;
			_orginPosition = orginPos.clone();
			_isResettable = isResettable;
			_isMarker = isMarker;
			
		}
		
		public function get physicsObj():RigidBody { return _physicsObj; }
		public function get name():String { return _name; }
		public function get isResettable():Boolean { return _isResettable; }
		public function get orginPosition():Number3D { return _orginPosition; }
		public function get isMarker():Boolean { return _isMarker; }
		
	}//end AdvancedPhysicsObject
	
}